/*
	$Id: inputaxis.h,v 1.1.1.1 2000/04/09 12:17:59 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! component="Input"

#ifndef header_inputaxis
#define header_inputaxis

class CL_InputAxis
//: Input Axis interface.
// CL_InputAxis is the interface to an input axis, such as a joystick axis.
{
public:
	virtual ~CL_InputAxis() { return; }
	virtual float get_pos()=0;
	//: Returns a value between -1 and 1. Zero means centered, and -1 and 1 
	//: means all-the-way to either side (up/down, left/right, whatever).
	//!retval: Current axis position.
};

#endif
