
//! component="System"

#ifndef header_keepalive
#define header_keepalive

class CL_KeepAlive
//: Keep alive callback interface.
// <p>If you want to add something that gets called in a
// CL_System::keep_alive() call, inherit this class and create an instance
// of it.</p>
{
public:
	CL_KeepAlive();
	// Constructs and registers the object as a keep_alive listener.
	
	virtual ~CL_KeepAlive();
	// Unregisters the object as a keep_alive listener.

	virtual void keep_alive()=0;
	// Called when CL_System::keep_alive() is called.
};

#endif
